<?php
            if ( ! defined( 'ABSPATH' ) ) {
        exit; // Exit if accessed directly
    }
    if(!class_exists('xa_combinational_rules'))
    {
        class xa_combinational_rules extends xa_valid_rules
        {

           function __construct(&$cart_array,$rules_array,&$running_max_discount,&$running_max,$price,$weight,$cart_keys)
            {
               if(empty($rules_array) || empty($price))
               {
                  
               }
               else
               {
                 $this->cart_keys=$cart_keys;
                 $this->cart_array=&$cart_array;
                 $this->rules_array=$rules_array;
                 $this->running_max_discount=&$running_max_discount;
                 $this->running_max=&$running_max;
                 $this->_price=$price;
                 $this->_weight=$weight;
                 $this->mode='combinational_rules';
                 
                 $this->update_product_valid_rules();
               }

                 
                 
            }
           
           function  update_product_valid_rules()
           {   
               $this->valid_rules=array();
                 foreach($this->rules_array as $rule1)
                 {
                     if($this->check_rule($rule1)===true)
                     {
                          $this->valid_rules[$rule1['rule_no']]=$rule1;
                     }
                      
                 }
           }
           
            function check_rule(&$rule)
           {
                        $prod_array=$this->cart_array;
                        $pids=$rule['product_id'];
                        $rule_no=$rule['rule_no'];
                        foreach ($pids as $pid=>$qnty)
                        {	
                                if(array_key_exists($pid,$prod_array) && $this->check_date_range_and_roles($rule,$pid) ==true &&  $this->check_min_quantity($rule,$pid,$qnty)==true )
                                {
                                        if ( !isset($rule['mapping'])  || !in_array($pid,$rule['mapping'])) 
                                        {	$rule['mapping'][]=$pid; 
                                        }
                                }
                                else
                                {
                                    return false;
                                }
                        }  
                        return true;
            }
        function check_min_quantity(&$rule,$pid,$min)
        {	
                extract($rule);
                if($discount_type=='Flat Discount'  && isset($this->running_max[$rule_no.":".$this->mode]['min'])  &&   $this->running_max[$rule_no.":".$this->mode]['min']==1 )
                {
                    return false;
                }
                if(isset($this->running_max_discount[$rule_no.":".$this->mode])  && $this->running_max_discount[$rule_no.":".$this->mode]<=0)
                {
                    return false;
                }

               if($this->cart_array[$pid]>=$min  && apply_filters('eha_dp_skip_product',false,$pid,$rule,$this->mode)==false)  
                {      
                    return true;                     
                }
                else
                {
                    return false;
                }
        
                return false;
        }

            function check_roles($role)
            {
                    if($role=='all' || current_user_can($role))
                    {
                            return true;
                    }

                    return false;
            }


            function check_date_range_and_roles($rule,$pid)
            {
                $fromdate=$rule['from_date'];
                $todate=$rule['to_date'];
                $user_role=$rule['allow_roles'];
                $offer_name=$rule['offer_name'];
                   if($this->check_roles($user_role)!=true)
                   {
                       return false;
                   }
                    $now=date('d-m-Y');
                    $return=false;
                    if(empty($fromdate) && empty($todate))
                    {
                            $return= true;
                    }
                    elseif(empty($fromdate) && empty($todate)==false  && (strtotime($now) <= strtotime($todate)))
                    {
                            $return= true;
                    }
                    elseif(empty($fromdate)==false && (strtotime($now) >= strtotime($fromdate)) && empty($todate))
                    {
                           $return= true;
                    }
                    elseif((strtotime($now) >= strtotime($fromdate))  && (strtotime($now) <= strtotime($todate)))
                    {
                            $return= true;
                    }
                    else
                    {
                            $return= false;
                    }
                    global $product;
                    if(is_product()==true && $return===true && !empty($product) && is_string($product)===false)
                    {
                        $cpid = is_wc_version_gt_eql('2.7')?$product->get_id():$product->id;
                        $prod=wc_get_product($pid);
                        
                        //$parent_id=is_wc_version_gt_eql('2.7')?$prod->get_parent_id():$prod->parent_id;
                        $parent_id=wp_get_post_parent_id( $cpid);
                        if($pid==$cpid  || $parent_id==$cpid)
                        {  
                            global $offers;
                            $offers['combinational_rules'][$rule['rule_no']]=$offer_name;
                        }
                    }
                    
                    return $return;
            }

            function get_min_valid_quantity($rule)
            {

                    $min_valid_qnty=1;
                    extract($rule);
                    if(!array_key_exists($product_id,$this->cart_array))
                    {
                            return false;
                    }
                    $unit_price=$this->_price[$product_id];
                    $unit_weight=$this->_weight[$product_id];

                    if($check_on=='Price')
                    {
                            if(!empty($this->_price) && array_key_exists($product_id,$this->_price)===true)
                            {
                                    $min_valid_qnty=ceil(floatval($min)/floatval($unit_price));
                            }
                    }
                    elseif($check_on=='Quantity')
                    {	if(!empty($this->_weight) && array_key_exists($product_id,$this->_weight)===true)
                            {
                                    $min_valid_qnty=ceil($min);
                            }
                    }
                    elseif($check_on=='Weight')
                    {
                            $min_valid_qnty=ceil(floatval($min)/floatval($unit_weight));
                    }
                    else
                    {
                            $min_valid_qnty=1;
                    }

                    return $min_valid_qnty;
            }
 

                    function get_valid_rules()
                    {
                       return parent::get_valid_rules();
                    }
       

                    public function possible_solutions(&$ps)
                    {           
                                    
                                    $mode=$this->mode;
                                    
                                    foreach( $this->valid_rules as $rule_no=>$rule )
                                    {  
                                        $cal_discount=0.0;
                                        $dp=0;
                                        $val=$rule['value'];
                                        $price=0;
                                        $max_discount=$this->running_max_discount[$rule_no.":".$mode];
                                            
                                        foreach ($rule['product_id'] as $pid=>$req_qnty)
                                        {
                                             if(!isset($this->cart_array[$pid]))
                                          {
                                                continue(2); 
                                          }        
                                            if($this->cart_array[$pid]==0)
                                                    {
                                                   unset($this->cart_array[$pid]);
                                                   continue(2);    
                                                    }
                                        $price+=$this->_price[$pid];
                                        }
                                        if($rule['discount_type']=='Percent Discount')
                                        {
                                                $cal_discount=(floatval($price)* $val)/100;
                                        }
                                        elseif($rule['discount_type']=='Flat Discount')
                                        {
                                                $cal_discount=floatval($val);
                                        }
                                        elseif($rule['discount_type']=='Fixed item Price'  || $rule['discount_type']=='Fixed Price' )
                                        {
                                                $cal_discount=floatval($price) - $val;
                                        }
                                        else
                                        {
                                                die('error on ref:23x22334,  message: discount_type is not set for rule no:'.$rule_no);
                                        }

                                        if($cal_discount>$max_discount && $max_discount<>0)
                                        {
                                                $cal_discount=$max_discount;
                                        }

                                        $dp=$cal_discount;	
                                        $dp=round($dp,wc_get_price_decimals(),PHP_ROUND_HALF_UP);
                                        $dp=strval($dp);
                                       if(!isset($ps[$rule_no.':'.$mode][$dp])  ||  !in_array(array($dp=>implode(',', array_keys($rule['product_id']))),$ps[$rule_no.':'.$mode][$dp]))
                                        $ps[$rule_no.':'.$mode][$dp]=array($dp=>implode(',', array_keys($rule['product_id'])));
                                    }
                    }   // end function possible_sollution
	
                    
                    public function execute_rule($rule_no,&$running_max_discount, $selected_prods) 
                    {         
                                if(is_cart() )
                                {
                                echo "\n<div id='rules_info' style='display:none'>";
                                echo "mode:".$this->mode."\t\t\trule:".$rule_no." \napa=";print_r($this->cart_array);

                               }
                               
                                $mode=$this->mode;
                                $rule=$this->valid_rules[$rule_no];
                                extract($rule);
                               
                                $dis=0;
                                $total_price=0;
                                $discount_amt=0;
                                $p_discount=0;
                                global $woocommerce;
                                $cart=$woocommerce->cart;
                                $p_max_dis=999999999999;
                                if(isset($running_max_discount[$rule_no.":".$mode]))
                                {
                                     $p_max_dis=$running_max_discount[$rule_no.":".$mode];
                                }
                               
                                foreach($product_id as $pid=>$qnty)
                                {      
                                       
                                        $min_valid_qnty=$qnty;
                                        $this->cart_array[$pid]-=$min_valid_qnty;
                                        $total_price+=(floatval($this->_price[$pid]) * floatval($min_valid_qnty));
                                        $p_price=floatval($this->_price[$pid]) * floatval($qnty);
                                        
                                        $p_discount=0;
                                         if($this->cart_array[$pid]==0)
                                        {
                                            unset($this->cart_array[$pid]);
                                        }
                                        if($discount_type=='Percent Discount')
                                        {	//echo $discount_amt;
                                                $p_discount=floatval($value) * $p_price/100;

                                        }
                                        elseif($discount_type=='Flat Discount')
                                        {
                                                $p_discount=floatval($value);
                                        }
                                if(isset($this->cart_keys[$pid])  && !empty($this->cart_keys[$pid]))
                                {
                                        if(isset($p_max_dis)  && $p_discount>$p_max_dis )
                                        {
                                                $p_discount=$running_max_discount[$rule_no.":".$mode];
                                        }
                                    $count=count($this->cart_keys[$pid]);
                                    foreach($this->cart_keys[$pid] as $cart_key)
                                    {
                                            if(isset($cart->cart_contents[$cart_key]['dynamic_discount']) && !empty($cart->cart_contents[$cart_key]['dynamic_discount']) && is_numeric($cart->cart_contents[$cart_key]['dynamic_discount']))
                                            {                                      
                                                $cart->cart_contents[$cart_key]['dynamic_discount']+=$p_discount/$count;                                      
                                            }
                                            else
                                            {                                       
                                                $cart->cart_contents[$cart_key]['dynamic_discount']=$p_discount/$count;                                    
                                            }
                                    }
                                    //$cart_key=$this->cart_keys[$pid];
                                    $p_max_dis-=$p_discount;
                                }
                                }
                                 if($discount_type=='Percent Discount')
                                        {	//echo $discount_amt;
                                                $discount_amt=floatval($value) * $total_price/100;

                                        }
                                        elseif($discount_type=='Flat Discount')
                                        {
                                                $discount_amt=floatval($value);
                                        }
                                        else
                                        {

                                        }
                                        if(isset($running_max_discount[$rule_no.":".$mode])  && $discount_amt>$running_max_discount[$rule_no.":".$mode] )
                                        {
                                                $discount_amt=$running_max_discount[$rule_no.":".$mode];
                                        }
                                         if(!empty($max_discount))
                                        {
                                            $running_max_discount[$rule_no.":".$mode]-=$discount_amt;
                                        }
                                        if(!isset( $this->running_max[$rule_no.":".$this->mode]['Quantity']))
                                          {
                                               $this->running_max[$rule_no.":".$this->mode]['Quantity']=0;
                                          }
                                          
                                        $this->running_max[$rule_no.":".$mode]["min"]=1;
                               
                              if(isset($adjustment) && is_numeric($adjustment))
                               {
                                    global $adjusted;
                                    if(!isset($adjusted[$mode][$rule_no]) || !$adjusted[$mode][$rule_no]==true)        // One time Rule Adjustment 
                                    {
                                        $adjusted[$mode][$rule_no]=true;
                                        $discount_amt-=$adjustment;
                                        if(isset($cart->cart_contents[$cart_key]['dynamic_discount']) && !empty($cart->cart_contents[$cart_key]['dynamic_discount']) && is_numeric($cart->cart_contents[$cart_key]['dynamic_discount']))
                                        {                                      
                                            $cart->cart_contents[$cart_key]['dynamic_discount']-=$adjustment;                                      
                                        }
                                        else
                                        {                                       
                                            $cart->cart_contents[$cart_key]['dynamic_discount']=-$adjustment;                                    
                                        }                                        
                                    }                                  
                               }
                            if(is_cart() )
                                {                               
                                echo "\n Apa=";print_r($this->cart_array);
                                echo "L-dis=".$discount_amt;
                                echo "</div>";
                               }
                                return $discount_amt;
                    }      //end function execute_rule();
                    
                    
                    
            }
    }